module Hermes
  module RexClient
    class UpdateStructureTask

      def update_entity(client = Hermes::RexClient::Client.new, rex_entity, className)
        fields = rex_entity['fields']
        return if fields['id_cristal'].blank?

        structure = className.constantize.find_by(id_cristal: fields['id_cristal'])

        if !structure
          structure = className.constantize.create(generate_structure_fields(fields))
        else
          structure.update(generate_structure_fields(fields))
        end

        if !fields['id_parent_cristal'].blank?
          parent_rex_entity = client.search_structures({"fields.id_cristal": fields['id_parent_cristal']}).first
          parent = update_entity(client, parent_rex_entity, className) if parent_rex_entity
          structure.parent_id = parent.id if parent
        end
        
        structure.save!
        structure
      end

      def generate_structure_fields(fields)      
        {
          title: fields['app_comm'],
          id_rex: fields['id'],
          id_cristal: fields['id_cristal'],
          id_parent_cristal: fields['id_parent_cristal'],
          siret: fields['siret'],
        }
      end
    end
  end
end
